import 'effect_system.dart';
import '../types/types.dart';
import '../systems/on_on_system.dart';

extension EffectSystemOnOperators<State, Event> on EffectSystem<State, Event> {

  EffectSystem<State, Event> onEvent({
    required void Function(State state, Event? event, Dispatch<Event> dispatch) effect,
  }) => forward(copy: (system) => system.onEvent(
    effect: effect
  ));

  EffectSystem<State, Event> on<ChildEvent>({
    ChildEvent? Function(Event event)? test,
    required void Function(State state, ChildEvent event, Dispatch<Event> dispatch) effect,
  }) => forward(copy: (system) => system.on(
    test: test,
    effect: effect,
  ));

  EffectSystem<State, Event> onLatest<ChildEvent>({
    ChildEvent? Function(Event event)? test,
    required Dispose? Function(State state, ChildEvent event, Dispatch<Event> dispatch) effect,
  }) => forward(copy: (system) => system.onLatest(
    test: test,
    effect: effect
  ));

  EffectSystem<State, Event> onRun({
    required void Function(State initialState, Dispatch<Event> dispatch) effect
  }) => forward(copy: (system) => system.onRun(
    effect: effect,
  ));

  EffectSystem<State, Event> onDispose({ 
    required void Function() run
  }) => forward(copy: (system) => system.onDispose(
    run: run,
  ));
}