
import '../types/types.dart';

class EffectForwarder<State, Event> {

  List<Effect<State, Event>> _effects = [];
  State? _state;
  Dispatch<Event>? _dispatch;

  void effect(State state, State? oldState, Event? event, Dispatch<Event> dispatch) {
    _effects.forEach(
      (_effect) => _effect(state, oldState, event, dispatch)
    );
    _state = state;
    _dispatch = dispatch;
  }

  Dispose add({
    required Effect<State, Event> effect
  }) {
    _effects.add(effect);
    if (_state != null && _dispatch != null) {
      effect(_state!, null, null, _dispatch!);
    }
    return Dispose(() {
      if (_effects.contains(effect)) {
        _effects.remove(effect);
      }
    });
  }
}