
abstract class Optional<T> {}

class OptionalNone<T> implements Optional<T> {}
class OptionalValue<T> implements Optional<T> {
  OptionalValue(this.value);
  final T value;
}

extension Map<T> on Optional<T> {

  R map<R>({
    required R none(),
    required R value(T value), 
  }) {
    if (this is OptionalNone<T>) {
      return none();
    } 
    final _value = (this as OptionalValue<T>).value;
    return value(_value);
  }

  Optional<R> mapValue<R>(R transform(T value)) => this.map(
    none: () => OptionalNone(),
    value: (value) => OptionalValue(transform(value)),
  );
}